%{
/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: cat_parser.y,v 1.1 2006/02/24 08:24:15 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: cat_parser.y,v $
 * Revision 1.1  2006/02/24 08:24:15  pipas
 * Initial revision
 *
 */
#include <gnome.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "cuiterm.h"
#include "cuilexelements.h"
#include "cat_parser.h"
#include "terminal.h"
#include "background.h"
#include "cuiwindow.h"

extern CuiWindow *window_for_lex;

%}

%debug
%parse-param {CuiWindow *window}
%union { 
	CuiLexElement sval;
}
 
%token <sval> COMMENT 
%token <sval> NEW_LINE FILE_END
%token <sval> LABEL FILENAME WORD
%%
lines: lines line
     | line
     ;

line: FILE_END {return 0;}
    | COMMENT lineend
    | LABEL '=' FILENAME FILENAME WORD optionlist WORD WORD lineend {
		cui_window_apply_tag(window, "FgCyan", $1.begin, $1.end); 
		cui_window_apply_tag(window, "block_device", $3.begin, $3.end); 
		cui_window_apply_tag(window, "directory", $4.begin, $4.end); 
		cui_window_apply_tag(window, "FgRed", $7.begin, $7.end); 
		cui_window_apply_tag(window, "FgRed", $8.begin, $8.end); 
      }
    | FILENAME FILENAME WORD optionlist WORD WORD lineend {
		cui_window_apply_tag(window, "block_device", $1.begin, $1.end); 
		cui_window_apply_tag(window, "directory", $2.begin, $2.end); 
		cui_window_apply_tag(window, "FgRed", $5.begin, $5.end); 
		cui_window_apply_tag(window, "FgRed", $6.begin, $6.end); 
      }
    | error { window->error_code++; }
    ;

optionlist: option
	  | optionlist ',' option
	  ;

option: WORD 		 { g_message("WORD"); }
      | WORD '=' WORD    { g_message("WORD = WORD"); }
      ;

lineend: 
       | NEW_LINE {
       #if 0
    		CuiWidget *widget;
		Background *bg = cui_widget_get_background(CUI_WIDGET(window));
		widget = cui_pixmap_new_from_package_file("enter.png");
		cui_widget_set_background(CUI_WIDGET(widget), bg);
		cui_widget_set_area_by_marks(CUI_WIDGET(widget), 
				$1.begin, $1.end);
       #endif
             }
       ;
%%

extern int cat_lineno;

int cat_error(CuiWindow *window, char *c )
{
	gchar *error_message;
	yydebug = 1;	
	error_message = g_strdup_printf(
		"Error in File: %s in line %d", 
		c, 
		cat_lineno);
	g_warning(error_message);
	cui_window_set_title(window, error_message);
	g_free(error_message);
	return(1);
}

int cat_wrap(void)
{
	g_message("%s(): returning 1", __func__);
	return 1;
}
