/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: cuilexelements.c,v 1.1 2006/02/24 17:22:18 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: cuilexelements.c,v $
 * Revision 1.1  2006/02/24 17:22:18  pipas
 * Initial revision
 *
 */
#include <gnome.h>
#include "cuilexelements.h"

void 
cui_lex_element_destroy(CuiLexElement *lex_element)
{
	GtkTextBuffer *buffer;
	g_return_if_fail(lex_element != NULL);
#ifdef DEBUG
	g_message("%s(): start on: '%s'", __func__, lex_element->text);
#endif

	buffer = gtk_text_mark_get_buffer(lex_element->begin);
	/*
	 * FIXME: We sometimes store the text mark in the widgets.
	 */
	//gtk_text_buffer_delete_mark(buffer, lex_element->begin);
	//gtk_text_buffer_delete_mark(buffer, lex_element->end);
	g_free(lex_element->text);

	lex_element->begin = NULL;
	lex_element->end = NULL;
	lex_element->text = NULL;
}

CuiLexElement 
cui_lex_element_add(
		CuiLexElement *lex1,
		CuiLexElement *lex2)
{
	CuiLexElement *ret;
	ret = g_new(CuiLexElement, 1);

	ret->begin = lex1->begin;
	ret->end = lex2->end;
	ret->text = g_strconcat(lex1->text, lex2->text, NULL);
	return *ret;
}

CuiLexElement 
cui_lex_element_build_path(
		CuiLexElement *dir1,
		CuiLexElement *separator,
		CuiLexElement *dir2)
{
	CuiLexElement *ret;
	ret = g_new(CuiLexElement, 1);

	ret->begin = dir1->begin;
	ret->end = dir2->end;
	ret->text = g_build_path(separator->text,
			dir1->text, 
			dir2->text,
			NULL);
	return *ret;
}

CuiLexElement *
cui_lex_element_dup(CuiLexElement *lex)
{
	CuiLexElement *_new = g_new(CuiLexElement, 1);
	
	g_assert(lex != NULL);
	_new->text = g_strdup(lex->text);
	_new->begin = lex->begin;
	g_object_ref(G_OBJECT(lex->begin));
	_new->end = lex->end;
	g_object_ref(G_OBJECT(lex->end));
	_new->double_val = lex->double_val;
	_new->type = lex->type;
	return _new;
}
			
