%{
/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: exit_lexer.l,v 1.1 2006/02/24 09:04:26 pipas Exp $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: exit_lexer.l,v $
 * Revision 1.1  2006/02/24 09:04:26  pipas
 * Initial revision
 *
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#define _GNU_SOURCE
#include <gnome.h>
#include <string.h>
#include "cuiwindow.h"
#include "bash_parser_c.h"
#include "ls_parser_c.h"
#include "exit_parser.h"

#undef YY_INPUT
extern CuiWindow *window_for_lex;
#define YY_INPUT(b, r, ms) (r = cui_window_get_char(window_for_lex, b, ms))

%}

%option yylineno

%%
[ \t\n\r]+ {
	/* White chars: just for skipping to the next token */
	cui_window_get_token_marks(window_for_lex, 
		yytext, NULL, NULL);	
}

"exit" {
	cui_window_get_token_marks(window_for_lex, 
		yytext, NULL, NULL);
}

"There are stopped jobs." {
	exit_lval.sval.text = strdup(yytext);
	cui_window_get_token_marks(window_for_lex, 
		exit_lval.sval.text,
		&exit_lval.sval.begin,
		&exit_lval.sval.end);
	cui_window_apply_tag(window_for_lex, "error_message", 
		exit_lval.sval.begin, 
		exit_lval.sval.end); 
	return ERROR_MESSAGE;
}

%%
