/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id:$
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log:$
 */
#ifndef HISTORY_H
#define HISTORY_H

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#define _GNU_SOURCE
#include <gtk/gtk.h>
#include "cuilexelements.h"

typedef enum ApplicationOpcode {
	OpTryAdd,
	OpReset,
	OpSearch
} ApplicationOpcode;

typedef struct file_read_progress {
	GtkWidget *appbar;
	gint       size;
	gint       red;
	gint       ifile;
} file_read_progress;

typedef struct app_freq {
	gchar *appname;
	gint  *freq;
} app_freq;

typedef struct _program_option program_option;
struct _program_option {
	gchar *option;
	gchar *description;
};

typedef struct _program_info program_info;
struct _program_info {
	gchar *name;		/* The name of the program. 		*/
	gchar *info;		/* One line description.		*/
	GList *longopts;
	GList *opts;
};

typedef enum {
	TypingNotChecked,
	TypingError,
	TypingCorrect
} TypingCheckResult;


gpointer history_read_bash_history(GtkWidget *widget);
gchar *handle_text_editors(gchar *appname, ApplicationOpcode opcode);
gboolean type_check_command_name(CuiLexElement *lexelement);
gboolean type_check_long_option(CuiLexElement *longopt, gchar *name);
gboolean program_add_longopt(gchar *name, gchar *longopt);
TypingCheckResult 
	program_check_longopt_typing(
			const gchar *name, 
			const gchar *longopt);

void on_history_close_button_clicked(GtkButton *button, gpointer user_data);
void on_history_treeview_realize(GtkWidget *widget, gpointer user_data);

#endif
