/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: ls_parser_c.h,v 1.1 2006/02/24 17:33:29 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: ls_parser_c.h,v $
 * Revision 1.1  2006/02/24 17:33:29  pipas
 * Initial revision
 *
 */
#ifndef LS_PARSER_C_H
#define LS_PARSER_C_H

#define FT_UNKNOWN 0
#define FT_FILE 1
#define FT_DIRECTORY 2
#define FT_LINK 3
#define FT_BLOCK 4
#define FT_CHAR 5

#include <gnome.h>
#include "cuiterm.h"
#include "cuilexelements.h"
#include "cuiwindow.h"
#include "background.h"
#include "widgets.h"
#include "filename.h"


CuiWidget *cui_entry_new_for_filename(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end,
		const char  *text);

CuiFileMenu *cui_file_menu_new_for_filename(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end);

CuiWidget *cui_action_area_new_for_filename(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end);

void cui_action_area_new_for_mode_owner(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end);

void
cui_action_area_new_for_mode_group(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end);

void
cui_action_area_new_for_mode_others(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end);

void cui_action_area_new_for_mode(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end);

CuiWidget *
cui_action_area_new_for_size(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end);
CuiWidget *
cui_action_area_new_for_owner(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end);
CuiWidget *
cui_action_area_new_for_group(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end);
CuiWidget *
cui_action_area_new_for_link(
		CuiWindow   *window,
		Background  *background,
		CuiFilename *file,
		GtkTextMark *begin,
		GtkTextMark *end);

/*
 * Old stuff...
 */
typedef struct _Direntry Direntry;
struct _Direntry {
	CuiLexElement sval;
	gint filetype;
};
void
ls_place_error_message(CuiWindow *window,
		char *token,
		GtkTextMark *mbegin,
		GtkTextMark *mend);

#endif
