%{
/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: who_parser.y,v 1.1 2006/02/24 08:15:09 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: who_parser.y,v $
 * Revision 1.1  2006/02/24 08:15:09  pipas
 * Initial revision
 *
 */
#include <gnome.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "cuiterm.h"
#include "cuilexelements.h"
#include "who_parser.h"
#include "terminal.h"
#include "background.h"
#include "cuiwindow.h"
#include "complex_widgets.h"

extern CuiWindow *window_for_lex;

%}

%debug
%parse-param {CuiWindow *window}
%union { 
	CuiLexElement sval;
}
 
%token <sval> HEADER
%token <sval> NAME LINE COMMENT
%token <sval> MONTH DATE FDATE TIME 
%type  <sval> comment

%%

lines: lines line
     | line
     ;

line: HEADER
    | NAME LINE timestamp comment { 
    		cui_widgets_new_for_filename(window, &$1);   
	}
    | error { window->error_code++; }
    ;

comment:         { $$.text = ""; } 
       | COMMENT { $$ = $1;      }
       ;

timestamp: MONTH DATE TIME
	 | FDATE TIME
         ;
%%

extern int who_lineno;

int who_error(CuiWindow *window, char *c )
{
	gchar *error_message;
	error_message = g_strdup_printf("Error in File: %s in lineno %d",
			c,
			who_lineno);
	g_warning(error_message);
	cui_window_set_title(window, error_message);
	g_free(error_message);
	return(1);
}

int who_wrap(void)
{
	g_message("%s(): returning 1", __func__);
	return 1;
}
